Inconsistent / Unpredictable behavior with servos - Broken track editor
Description

I've been dealing with this issue for months now hoping it would eventually be addressed in an update, and seeing as it hasn't been
fixed and I've reached the end of my patience tonight | figured I'd at least try submitting a bug report.

The track editor is broken. Servos and other robotics are completely inconsistent when controlled via the track editor as well. 'Toggle
lock' for servos is completely useless and constantly kicks out the "Cannot lock robotic part, servo is moving." error. Mirroring servos
and controlling them via the track editor almost always results in improper behavior. Even adding servos and controlling them
individually results in only half of them working.

Here's a reddit post | made regarding just one of the various servo related issues I've had:
https://www.reddit.com/r/KerbalSpaceProgram/comments/feyk59/error_cannot_lock_robotic_part_servo_is_moving/

Here's a video | recorded tonight featuring a simple robotic landing gear system completely failing to function:
https://www.youtube.com/watch?v=nusrWjOHIxk&feature=youtu.be

I'm not going to go into any more detail because it's simply not necessary. Launch your game and experiment for fifteen minutes with
some basic multi-servo vehicles and you'll notice what the issues are.

History

#1 - 03/11/2020 02:29 AM - Anth12

Video is Private. | cant see it

#2 - 03/11/2020 02:41 AM - Anth12

Also can you upload the craft with the issue?

#3 - 03/11/2020 03:10 PM - Samg381
- File F45B V.craft added

Anth12 wrote:

Also can you upload the craft with the issue?

Take off from the runway and open/close the landing gear. Take note the behavior of the folding landing gear bay doors.
The behavior is also noticeable in VTOL mode. Before taking off, press the 'Abort' button and notice the error message that occurs ~10 seconds later.

#4 - 03/11/2020 03:12 PM - Samg381
Anth12 wrote:

Video is Private. | cant see it

Apologies. I've set the video to unlisted.. It documents the same issue in the craft | described in my other comment reply.
Skip to around the six minute mark.

#5 - 03/17/2020 06:28 AM - Anth12
https://www.reddit.com/r/KerbalSpaceProgram/comments/feyk59/error_cannot_lock_robotic_part_servo_is_moving/
https://www.youtube.com/watch?v=nusrWj0Hlxk&feature=youtu.be

Tested the craft. There is an issue.
| will do some further testing to see what exactly happening to see if its something Squad should be looking at, or is a design issue.

#6 - 03/17/2020 03:29 PM - Anth12
- File F45B V Anth12 Variation.craft added

Samg381 | have attached a slightly modified version of your plane.
The problem seemed to be for some reason your gear/hinge was hitting other parts when they shouldnt have been.
| did the following:

e | removed and deleted the hinges + landing gear on both sides

¢ | recreated the hinge and landing gear and put them in symmetry in approximately the same place (pulling the parts fresh from the menu)

¢ In the 'Gear Bus' | moved the lock/unlock to points where the movement of the hinges would have been in the final position for an exaggerated
amount of time to ensure that the hinge had stopped before the lock/unlock engaged

¢ Landing gear is the first thing to retract, then the last thing to extend.

¢ | increased the runtime of the controller 'Gear Bus'to 15 seconds, more for testing to see the entire process work correctly than anything.

Removed landing gear Retract/Extend from the Gear Action Group because the 'Gear Bus' is controlling it instead.

My hunch would be that parts were set to same vehicle interaction, then were turned off, but didn't actually turn off.

With my testing | pulled the mechanism apart and tested each part. The hinge and/or landing gear were pushing against parts around them causing
them to not move into position and keep trying (without success) to get into the required position which is why locking/unlocking didnt work, until |
replaced the hinge and gear.

Does the propeller part of it work? Wasnt quite sure how to get that running.
Impressive design.

Need to do more testing before | can confirm its a bug though.

#7 - 03/17/2020 03:36 PM - Samg381

Thank you for the diagnostics. The ducted fan can be activated using the Abort key.

For the sake of testing, you may also use the hinge on the door above the ducted fan as another source of locking failure without many other nearby
moving parts. The door should unlock and open when the abort key is clicked and close + lock when clicked again. I've made significant
improvements in the VTOL capability since posting last, however these locking issues have persisted.

One working hypothesis of mine is that the logic controllers do not play well with multiple nodes positioned at the same time within the track editor.
This will of course require further testing.

#8 - 03/17/2020 11:49 PM - Anth12

Do note, that wasnt a diagnosis. | fixed the landing gear, they work perfectly now.

| was explaining my theory of what was causing the issue you experienced and how | fixed it

#9 - 03/18/2020 11:24 AM - just_jim
- Status changed from New to Confirmed
- Assignee set to just_jim

- % Done changed from 0 to 10

| had to mess with it a bit, but | was able to repro the error message.

Note: | had to mess with it a bit, but was able to repro the error with the attached F45B V craft. The 4th sequencer is the problem. It's bound to the G
key, and is tied to the landing gear, and is a fairly impressive set-up. But if you start hitting the G key too fast, or while they're still in motion, it can
reach a point where the servo will try to lock while it's still moving, and the error message shows up. This should not happen.

What i did was hold the jet in place with launch clamps on the runway, and just extend and retract the landing gear... Again, try extending them, then
retracting before they're fully extended... or vice versa... After a couple attempts you should be able to trigger the error. It only took a few seconds to
repro it for me once | knew what to look for.

#11 - 03/19/2020 10:44 AM - Anth12

good to know
#12 - 03/20/2020 04:31 PM - Samg381
Thank you for confirming the issue. Please let me know if anything further is required or if | can help in any way.

Looking forward to this issue being rectified.

#13 - 04/24/2020 07:19 PM - Samg381
- File deleted (F45B V.craft)
- File deleted (F45B V Anth12 Variation.craft)

#14 - 10/22/2020 02:22 AM - Samg381

This is still an issue. Bumping for support.

#15 - 01/01/2021 11:02 PM - Samg381

Still an issue. Please fix this.

#16 - 01/01/2021 11:04 PM - Samg381

just_jim wrote:
| had to mess with it a bit, but | was able to repro the error message.
Note: | had to mess with it a bit, but was able to repro the error with the attached F45B V craft. The 4th sequencer is the problem. It's bound to
the G key, and is tied to the landing gear, and is a fairly impressive set-up. But if you start hitting the G key too fast, or while they're still in
motion, it can reach a point where the servo will try to lock while it's still moving, and the error message shows up. This should not happen.
What i did was hold the jet in place with launch clamps on the runway, and just extend and retract the landing gear... Again, try extending them,

then retracting before they're fully extended... or vice versa... After a couple attempts you should be able to trigger the error. It only took a few
seconds to repro it for me once | knew what to look for.

Can | have a status update on the progress being made on this issue? Thank you.

Edit 2023: This is still an issue.

Files
